poj2288(Islands and Bridges) 状压DP

题目链接:http://poj.org/problem?id=2288

题意:每个点有一个权值Vi,找一条哈密顿路径,路径的权值来自三条:1 路径上的Vi之和 2 所有相邻点对ij的Vi*Vj之和 3 相邻连续三点i,j,k(并且三点要构成三角形)Vi*Vj*Vk之和。

解法:dp[st][i][j]表示从j走到i并且剩下集合st没有走的最大权值。关于路径书,在转移的时候顺便计算即可;这道题令自己恶心了好久,最后原因是自己犯了一个严重错误,题目读错了,没有读到Vi*Vj*Vk要保证ijk能够构成一个三角形,在程序改一点判断ik是否有边即可。当然还要注意路径数可能超int,以及特判一个点的情况;

代码:

/******************************************************
* @author:xiefubao
*******************************************************/
#pragma comment(linker, "/STACK:102400000,102400000")
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <stack>
#include <string.h>
//freopen ("in.txt" , "r" , stdin);
using namespace std;

#define eps 1e-8
#define zero(_) (abs(_)<=eps)
const double pi=acos(-1.0);
typedef long long LL;
const int Max=14;
const int INF=1e9+7;

int num[Max];
LL dp[1<<Max][Max][Max];
LL cnt[1<<Max][Max][Max];
bool rem[Max][Max];
vector<int> vec[Max];
int n,m;
LL getdp(int st,int i,int j)
{
    if(dp[st][i][j]!=-1)
        return dp[st][i][j];
    LL ans=-INF;
    LL sum=0;
    for(int l=0; l<vec[i].size(); l++)
    {
        int k=vec[i][l];
        if((st&(1<<k))==0) continue;
        if()
        LL tool=getdp(st-(1<<k),k,i)+num[k]*num[i]+num[k]*num[i]*num[j];
        if(tool==ans)
            sum+=cnt[st-(1<<k)][k][i];
        if(tool>ans)
        {
            sum=cnt[st-(1<<k)][k][i];
            ans=tool;
        }
    }
    cnt[st][i][j]=sum;
    return dp[st][i][j]=ans;
}
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        memset(rem,0,sizeof rem);
        scanf("%d%d",&n,&m);
        int sum=0;
        for(int i=0; i<n; i++)
            scanf("%d",num+i),sum+=num[i],vec[i].clear();
        for(int i=0; i<m; i++)
        {
            int a,b;
            scanf("%d%d",&a,&b);
            a--,b--;
            if(a==b)
                continue;
            vec[a].push_back(b);
            vec[b].push_back(a);
            rem[a][b]=1;
            rem[b][a]=1;
        }
        if(n==1)
        {
            printf("%d %d\n",num[0],1);
            continue;
        }
        memset(dp,-1,sizeof dp);
        memset(cnt,0,sizeof cnt);
        for(int i=0; i<n; i++)
            for(int j=0; j<n; j++)
            {
                dp[0][i][j]=-INF;
                if(!rem[i][j])continue;
                dp[0][i][j]=0;
                cnt[0][i][j]=1;
            }
        LL ans=-INF;
        LL out=0;
        for(int i=0; i<n; i++)
            for(int j=0; j<n; j++)
            {
                if(!rem[i][j])
                    continue;
                LL tool=getdp((1<<n)-(1<<i)-(1<<j)-1,i,j)+num[i]*num[j];
                if(ans==tool)
                    out+=cnt[(1<<n)-(1<<i)-(1<<j)-1][i][j];
                if(ans<tool)
                {
                    ans=tool;
                    out=cnt[(1<<n)-(1<<i)-(1<<j)-1][i][j];
                }
            }
        if(out==0||ans<=0)
            printf("0 0\n");
        else
            cout<<ans+sum<<" "<<out/2<<endl;
    }
    return 0;
}
/*
6 15
1 1 1 1 1 1
1 2
1 3
1 4
1 5
1 6
2 3
2 4
2 5
2 6
3 4
3 5
3 6
4 5
4 6
5 6
*/

poj2288(Islands and Bridges) 状压DP

时间: 2024-10-16 14:34:10

poj2288(Islands and Bridges) 状压DP的相关文章

poj 2288 Islands and Bridges ——状压DP

题目:http://poj.org/problem?id=2288 状压挺明显的: 一开始写了(记忆化)搜索,但一直T: #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> using namespace std; typedef long long ll; int const inf=0x3f3f3f3f; int T,n,m,v[15]; ll ans,cnt

POJ 2288 Islands and Bridges(状压dp)

Language: Default Islands and Bridges Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 9312   Accepted: 2424 Description Given a map of islands and bridges that connect these islands, a Hamilton path, as we all know, is a path along the b

POJ2288:Islands and Bridges(状态压缩)

Description Given a map of islands and bridges that connect these islands, a Hamilton path, as we all know, is a path along the bridges such that it visits each island exactly once. On our map, there is also a positive integer value associated with e

状压dp,区间dp,矩阵快速幂

DP 首先先回忆一下dp,dp叫做记忆化搜索,是一种可以把暴力搜索中重复的部分重复利用,从而到达减小复杂度的目的.比如最应该熟悉的背包模型,如果你把选择的过程看成一步一步的,那么在这么多的搜索路径中一定有着很多很多的重复部分,dp就是一种把重复的部分加以利用的方法.相信大家都已经在以前的练习中已经明白了dp是什么样的思路了,接下来的两种dp会在大家已经了解经典的背包dp等模型下展开. 状态压缩dp: 首先先讲一个状压dp最最经典的模型,求哈密尔顿路径问题,也叫做旅行商问题:给你一张图,你要在每个

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6